#    This is a part of the "Prototype Tagger", an unsupervised POS tagger developed
#    in the Hebrew University by Omri Abend, Roi Reichart and Ari Rappoport.
#    Copyright (C) 2010  Omri Abend, Roi Reichart and Ari Rappoport
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#    If you have any questions, feel free to contact us in:
#    omria01@cs.huji.ac.il, roiri@cs.huji.ac.il
#
#    Please read the README file for more details.
#
#!/usr/local/bin/python
import os, re

# Runs the CCL parser in order to extract a lexicon.
class lexicon_extractor:
    
    def __init__(self, settings):
        self._settings = settings
    
    def run(self):
        
        lexicon_filename = self._settings.get_string("LEXICON_FILE")
        corpus_name = self._settings.get_string("INPUT_CORPUS")
        
        ccl_parser_input_f = open("ccl_parser_input_file","w")
        ccl_parser_input_f.write(corpus_name + " line learn -s empty -p -o "+lexicon_filename)
        ccl_parser_input_f.close()
        
        self._settings.set_string("LEXICON_FILE", lexicon_filename+".empty.lexicon")

        ccl_parser_path = self._settings.get_string("CCL_PARSER_DIRECTORY")

        os.system(ccl_parser_path+"/cclparser ccl_parser_input_file")


