#    This is a part of the "Prototype Tagger", an unsupervised POS tagger developed
#    in the Hebrew University by Omri Abend, Roi Reichart and Ari Rappoport.
#    Copyright (C) 2010  Omri Abend, Roi Reichart and Ari Rappoport
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#    If you have any questions, feel free to contact us in:
#    omria01@cs.huji.ac.il, roiri@cs.huji.ac.il
#
#    Please read the README file for more details.
#
#!/usr/local/bin/python
import os, sys, settings_loader

# Cleans temporary files created during the run of the tagger.

def clean_files(settings):

    # The morfessor clean
    morfessor_dir = settings.get_string("MORFESSOR_DIRECTORY")+"/train/"
    old_dir = os.getcwd()
    os.chdir(morfessor_dir)
    os.system(settings.get_string("MAKEFILE_DIR")+"/make realclean")
    os.chdir(old_dir)
    
    # other files to delete
    files_to_delete = ["ccl_parser_input_file", settings.get_string("MORFESSOR_FILENAME"), 
                       settings.get_string("MORFESSOR_FILENAME")+".gz",
                       settings.get_string("MORPHO_CLUSTERING_FILE"),
                       settings.get_string("LEXICON_FILE")+".empty.lexicon",
                       settings.get_string("LEXICON_FILE")+".empty"]
    
    for filename in files_to_delete:
        try:
            os.remove(filename)
        except OSError:
            continue
# END OF METHOD
    
if len(sys.argv) != 2:
    print 'Usage: prototype_tagger_clean <settings file>'
    sys.exit(-1)
  
settings = settings_loader.load_settings(sys.argv[0], sys.argv[1])

clean_files(settings)
