#    This is a part of the "Prototype Tagger", an unsupervised POS tagger developed
#    in the Hebrew University by Omri Abend, Roi Reichart and Ari Rappoport.
#    Copyright (C) 2010  Omri Abend, Roi Reichart and Ari Rappoport
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#    If you have any questions, feel free to contact us in:
#    omria01@cs.huji.ac.il, roiri@cs.huji.ac.il
#
#    Please read the README file for more details.
#
#!/usr/local/bin/python

import sys, re

# A sequencer for strings
class sequencer():
    
    def __init__(self):
        self._cur_max = 0
        self._words = dict()
    
    def get(self, word):
        
        output = self._words.get(word, None)
        if output != None:
            return output
        self._words[word] = self._cur_max 
        self._cur_max += 1
        return self._words[word]
        
    def get_max(self):
        return self._cur_max
    
    def print_sequencer(self):
        inv_dict = dict([(x[1], x[0]) for x in self._words.items()])
        for key in inv_dict.keys():
            print key, inv_dict[key]

    def get_reversed_dictionary(self):
        return dict([(x[1], x[0]) for x in self._words.items()])
    
    def inv_get(self, index):
        for key in self._words.keys():
            if self._words[key] == index:
                return key
# END OF CLASS
